MKTHNUM - K-th Number

You are working for Macrohard company in data structures department. After failing your previous task about key insertion you were asked to write a new data structure that would be able to return quickly k-th order statistics in the array segment.

That is, given an array a[1 ... n] of different integer numbers, your program must answer a series of questions Q(i, j, k) in the form: "What would be the k-th number in a[i ... j] segment, if this segment was sorted?"

For example, consider the array a = (1, 5, 2, 6, 3, 7, 4). Let the question be Q(2, 5, 3). The segment a[2 ... 5] is (5, 2, 6, 3). If we sort this segment, we get (2, 3, 5, 6), the third number is 5, and therefore the answer to the question is 5.

Input

The first line of the input contains n — the size of the array, and m — the number of questions to answer (1 ≤ n ≤ 100000, 1 ≤ m ≤ 5000).

The second line contains n different integer numbers not exceeding 10^9 by their absolute values — the array for which the answers should be given.

The following m lines contain question descriptions, each description consists of three numbers: i, j, and k (1 ≤ i ≤ j ≤ n, 1 ≤ k ≤ j - i + 1) and represents the question Q(i, j, k).

Output

For each question output the answer to it — the k-th number in sorted a[i ... j] segment.

Example

Input:
7 3
1 5 2 6 3 7 4
2 5 3
4 4 1
1 7 3

Output:
5
6
3

Note: a naive solution will not work!!!


Added by:psetter
Date:2009-02-24
Time limit:1s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ERL JS-RHINO
Resource:Northeastern Europe 2004 Northern Subregion

hide comments
2016-06-24 21:10:51
binary search +persistence segment tree..
binary search over -10^9 to +10^9 got tle..
binary search over elements of arr got ac..
log(2*10^9) factor proved very costly than log(10^5)... :-)
2016-01-01 19:01:50
@anando_du same thing happened to me , your comment was helpful
2015-10-18 20:39:53 Abhinandan Agarwal
N(log N)+M(log N)**3 solution gives TLE .. :-\
2015-09-29 19:14:58 Sudharsansai
Learnt a lot .
Merge Sort Tree : O((N+M)*lgN*lgN)
Persistent Segment Tree : O((N+M)*lgN)
2015-09-26 04:15:28 Shahed Shahriar
in c++(g++4.3.2) got WA and with the same code got AC in c++14 (g++5.1)
2015-09-01 08:52:34 Pulkit Singhal
Persistent Segment Tree Nailed It :D
2015-07-22 12:05:51 anando_du
used scanf() printf() got AC ..
used getchar_unlocked() , putchar_unlocked() got wa O.o
btw nice one !
2015-07-03 16:29:21 ankit kumar
!micro !soft=macro hard; hahaha nyc.. problem indeed!!
2015-06-10 16:56:38 i_am_looser
persistent segment tree. Got AC using O(nlog(n)) ; )
2014-01-19 15:09:58 gyosh
Beautiful problem. There exists solution which run in O(log^3 N), O(log^2 N), and O(log N) per query. Explore them and learn something new!

not as beautiful as you

Last edit: 2015-04-03 01:00:56
© Spoj.com. All Rights Reserved. Spoj uses Sphere Engine™ © by Sphere Research Labs.